
module SurfaceGen
	class Array2D
		def initialize(dx,dy)
			@dx = dx
			@dy = dy
			@data = Array.new(@dx*@dy)
		end

		def [](x, y) @data[y*@dx+x] end
		def []=(x, y, value) @data[y*@dx+x] = value end

		def width() @dx end
		def height() @dy end
		def dx() @dx end
		def dy() @dy end
	end

	class Array3D
		def initialize(dx,dy,dz)
			@dx = dx
			@dy = dy
			@dz = dz
			@data = Array.new(@dx*@dy*@dz)
		end

		def [](x, y, z) @data[(z*@dy+y)*@dx+x] end
		def []=(x, y, z, value) @data[(z*@dy+y)*@dx+x] = value end
		
		def width() @dx end
		def height() @dy end
		def depth() @dz end
		def dx() @dx end
		def dy() @dy end
		def dz() @dz end
	end
end
