module SurfaceGen
	class SurfaceGenSelectionObserver < Sketchup::SelectionObserver
		def initialize()
			@visible = false
		end
	
		def update(selection)
			@oldvisible = @visible
			@visible = ((selection.length == 1) and (selection[0].get_attribute(ATTR_DICTIONARY, "isGraph", false)))
			if @visible then
				if SurfaceGen::dialog.visible? then
					SurfaceGen::dialog.set_size(WINDOW_WIDTH, WINDOW_HEIGHT) if (@visible != @oldvisible)
					SurfaceGen::updateJS
					SurfaceGen::dialog.execute_script("document.body.style.display='none';document.body.style.display='block';")
				else
					SurfaceGen::dialog.set_size(WINDOW_WIDTH, WINDOW_HEIGHT)
					SurfaceGen::dialog.set_background_color SurfaceGen::dialog.get_default_dialog_color
					
					if (PLATFORM == :mac) then
						SurfaceGen::dialog.show_modal {
							SurfaceGen::updateJS
							SurfaceGen::dialog.execute_script("document.body.style.display='none';document.body.style.display='block';")
						}
					else
						SurfaceGen::dialog.show {
							SurfaceGen::updateJS
							SurfaceGen::dialog.execute_script("document.body.style.display='none';document.body.style.display='block';")
						}
					end
				end
			else
				if SurfaceGen::dialog.visible?
					SurfaceGen::dialog.set_size(WINDOW_WIDTH, 0) if (@visible != @oldvisible)
				end
			end
		end
		
		def onSelectionBulkChange(selection)
			update(selection)
		end
		
		def onSelectionCleared(selection)
			update(selection)
		end
    end
	
	class SurfaceGenInstanceObserver < Sketchup::InstanceObserver
		def onOpen(instance)
			result = UI.messagebox("Warning: This action will convert the object into a regular group. Continue?", MB_YESNO)
			if result == 6 then
				instance.set_attribute(ATTR_DICTIONARY, "isGraph", false)
				instance.remove_observer self
			else
				Sketchup.active_model.close_active
			end
		end
	end
end
